"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _QueryBuilder = _interopRequireDefault(require("./QueryBuilder"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/**
  * id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL DEFAUL '' +
  */
class Column {
  _primaryKey = false;
  _autoIncrement = false;
  _nullable = false;
  constructor(name, type) {
    this.name = name;
    this.type = type;
  }
  primaryKey() {
    this._primaryKey = true;
    return this;
  }
  autoIncrement() {
    this._autoIncrement = true;
    return this;
  }
  defaultVal(defaultVal) {
    this._defaultVal = defaultVal;
    return this;
  }
  nullable() {
    this._nullable = true;
    return this;
  }
  compile() {
    var sql = [];
    // column-def:
    sql.push(this.name);
    sql.push(" ");
    sql.push(this.type);
    // column-constraint:
    if (this._primaryKey) sql.push(" PRIMARY KEY");
    if (this._autoIncrement) sql.push(" AUTOINCREMENT");
    sql.push(this._nullable ? " NULL" : " NOT NULL");
    if (this._defaultVal != null) {
      sql.push(" DEFAULT ");
      sql.push(_QueryBuilder.default.escapeSqlString(this._defaultVal));
    }
    return sql.join("");
  }
}
exports.default = Column;
//# sourceMappingURL=Column.js.map